normal_width=320
normal_height=452-52
landscape_width=480
landscape_height=320-52
scrollHeight=1000;		//	change to comfort level
fontHeight=8;			//	this is the height of the font being used

var TermAssistant = Class.create( {

	setup : function() {

		document.addEventListener("keydown", this.onKeyDown, true);
		document.addEventListener("keyup", this.onKeyUp, true);
                document.addEventListener("gesturestart", this.gestureStartHandler, true );
                document.addEventListener("gesturechange", this.gestureChangeHandler, true );
                document.addEventListener("gestureend", this.gestureEndHandler, true );
		
		//App Menu - Remove default items and add only Help items.
		var appMenuModel = {

			visible: false,
			items: [
				{label:$L('Respawn'), command:'term-menu-respawn'},
				{label:$L('Preferences'), command:'term-menu-prefs'},
			]
		
		};
		this.controller.setupWidget(Mojo.Menu.appMenu, {omitDefaultItems:false}, appMenuModel);
                this.controller.window.PalmSystem.setWindowOrientation('free');

/*
                this.controller.setupWidget("scrollerId",
                  this.attributes = {
                    mode: 'vertical'
                  },
                  this.model = {
                  }
                );
                */


		// Create plugin
		termPlugin = document.createElement('object');
		termPlugin.type = 'application/x-webosinternals-termplugin';
		termPlugin.width = normal_width;
		//termPlugin.height = normal_height;
                full_height = scrollHeight * fontHeight;
		termPlugin.height = full_height;
                this.onTap = this.onTap.bind(this);
                document.addEventListener(Mojo.Event.tap,this.onTap,true);
                //this.onMouseDown = this.onMouseDown.bind(this);
                Mojo.Event.listen(termPlugin,'mousedown',this.onMouseDown,true);
                Mojo.Event.listen(termPlugin,'mouseup',this.onMouseUp,true);
                Mojo.Event.listen(termPlugin,'flick',this.onFlick,true);
                //Mojo.Event.listen(sampleAdapterApp,'mouseup',this._adapterMouseUp,true);
                //Mojo.Event.listen(sampleAdapterApp,'mousemove',this._adapterMouseMove,true);


		// Listen for callback
		termPlugin.eventListener = this;

		// Embed plugin into scene
		var placeholder = document.getElementById('install_object_here');
		placeholder.parentNode.replaceChild(termPlugin,placeholder);
		termPlugin.setTerminalHeight(full_height);
		termPlugin.initialize();
                termPlugin.focus();

                //this.modesModel = {scrollbars:true,mode:"free"};
                //this.controller.setupWidget('scrollerId',{},this.modesModel);
                scroller=this.controller.get('scrollerId')
                // for some reason the height is 5 pixels less than what we ask for 
                this.orientationChanged("top");

	},

        handleCommand_dummy : function(event) {
                termPlugin.test('handleCommand');
        },

        orientationChanged : function(orientation) {
                var new_height;
                if (orientation==="left" || orientation==="right") {
                        termPlugin.width = landscape_width;
                        new_height = landscape_height;
                }
                else {
                        termPlugin.width = normal_width;
                        new_height = normal_height;
                }
                termPlugin.setTerminalHeight(new_height);
                scroller.setStyle({"height":new_height+5+"px"});
                if (scroller.mojo) {
                        scroller.mojo.revealBottom();
                }
        },

	activate : function (event) { 
                scroller.mojo.revealBottom();
        },

	onTap : function (event) {

          termPlugin.sendTap(event.down.screenX,event.down.screenY);

	},

	onKeyDown : function(event) {
          if (event.keyCode==13) {
            // This is the one key that won't get through to the terminal.
            termPlugin.sendEnter();
          }
	},

        gestureStartHandler : function(event) {
                termPlugin.sendGestureStart();
        },

        gestureEndHandler : function(event) {
                termPlugin.sendGestureEnd();
        },

        gestureChangeHandler : function(event) {
                termPlugin.sendGestureChange();
        },

	onKeyUp : function(event) {

		termPlugin.sendKeyUp(event.keyCode);
	},

	onKeyPress : function(event) {

		termPlugin.sendKeyPress(event.charCode);

	},

        onMouseDown : function(event) {
          termPlugin.sendMouseDown(event.screenX,event.screenY);
        },

        onMouseUp : function(event) {
          termPlugin.sendMouseUp(event.screenX,event.screenY);
        },

        onFlick : function(event) {
          termPlugin.sendFlick(event.screenX,event.screenY);
        },

	MainWindowQueueProcess : function (interval) {
	
		this.MainWindowQueueProcessIntervalID = setInterval(function() {} ,interval);
		
	},

        handleShortcut : function(which,event) {
                console.log('in handleShortcut');
        }
	
});
